unit ProcView;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, ActnList,
  ExtCtrls, StdCtrls;

type
  TProcForm = class(TForm)
    StatusBar: TStatusBar;
    ToolBar1: TToolBar;
    ImageList: TImageList;
    ToolButton2: TToolButton;
    ActionList: TActionList;
    SaveAction: TAction;
    EditPanel: TPanel;
    ListView: TListView;
    CompanyEdit: TEdit;
    ModelEdit: TEdit;
    KmEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ToolButton3: TToolButton;
    NewAction: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    CancelAction: TAction;
    procedure FormCreate(Sender: TObject);
    procedure NewActionExecute(Sender: TObject);
    procedure SaveActionExecute(Sender: TObject);
    procedure CancelActionExecute(Sender: TObject);
  private
    procedure SetStatusBarVersion;
    procedure SetModeView;
    procedure SetStatusOK;
  end;

var
  ProcForm: TProcForm;

implementation

{$R *.lfm}

{ TProcForm }

procedure TProcForm.FormCreate(Sender: TObject);
begin
  SetStatusBarVersion;
end;

procedure TProcForm.NewActionExecute(Sender: TObject);
begin
  CompanyEdit.Clear;
  ModelEdit.Clear;
  KmEdit.Clear;
  EditPanel.Visible := True;
  NewAction.Enabled := False;
  SaveAction.Enabled := True;
  CancelAction.Enabled := True;
end;

procedure TProcForm.SaveActionExecute(Sender: TObject);
var
  item: TListItem;
  km: Longint;
begin
  if not TryStrToInt(KmEdit.Text, km) then
  begin
    MessageDlg(Caption, 'Invalid Km/h', mtWarning, [mbOK], '');
    exit;
  end;

  item := ListView.Items.Add;
  item.SubItems.Add(CompanyEdit.Text);
  item.SubItems.Add(ModelEdit.Text);
  item.SubItems.Add(km.ToString);

  SetStatusOK;
  SetModeView;

  MessageDlg(Caption, 'Saved', mtInformation, [mbOK], '');
end;

procedure TProcForm.CancelActionExecute(Sender: TObject);
begin
  if MessageDlg(Caption, 'Cancel?', mtConfirmation, mbYesNo, 0, mbNo) = mrNo then
    exit;
  SetModeView;
end;

procedure TProcForm.SetStatusBarVersion;
begin
  StatusBar.Panels[0].Text := '1.0'; // get version using some object
end;

procedure TProcForm.SetModeView;
begin
  EditPanel.Visible := False;
  NewAction.Enabled := True;
  SaveAction.Enabled := False;
  CancelAction.Enabled := False;
end;

procedure TProcForm.SetStatusOK;
begin
  StatusBar.Panels[1].Text := 'Saving...';
  StatusBar.Repaint;
  Sleep(1500); // database persistence simulation
  StatusBar.Panels[1].Text := '';
end;

end.

